<!DOCTYPE html(lang='en')>
<html>
<head>
	<meta charset="UTF-8">
	<title>Details of a task</title>
	<script src="https://use.fontawesome.com/3ffec61ef7.js"></script>
	<!-- Bootstrap -->
	
	<script src="//ajax.googleapis.com/ajax/libs/jquery/1.11.0/jquery.min.js"></script>
	<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.6/css/bootstrap.min.css">
	
	<!-- <link rel="stylesheet" href="https://js.arcgis.com/3.20/esri/css/esri.css"> -->
	<link rel="stylesheet" href="https://js.arcgis.com/3.20/esri/themes/calcite/dijit/calcite.css">
	<link rel="stylesheet" href="https://js.arcgis.com/3.20/esri/themes/calcite/esri/esri.css">
	<script src="https://js.arcgis.com/3.20/"></script>

	<style type="text/css">
	#info {
			top: 20px;
			color: #444;
			height: auto;
			font-family: arial;
			right: 20px;
			margin: 5px;
			padding: 10px;
			position: absolute;
			width: auto;
			z-index: 40;
			border: solid 2px #666;
			border-radius: 4px;
			background-color: #fff;
		  }
		  html, body, #mapDiv {
			padding:0;
			margin:0;
			height:90%;
		  }
		  button {
			display: block;
		  }
	</style>
	
	
	<script src="localDependency.js"></script>
	
	<script type="text/javascript">
	
	$( document ).ready(function() {
	
	var userHashCode = sessionStorage.hashCode
		var taskName = sessionStorage.taskID;
		var completedTaskArray;	
		var taskHashCode = hashFnv32a(taskName,false);
		var email = sessionStorage.email;
		var completedTaskArrayText = sessionStorage.completedTaskArray;
		
		if ( completedTaskArrayText != null )
		{
			completedTaskArray = JSON.parse(completedTaskArrayText);
		}
		else
		{
			completedTaskArray = [];
		}
		
		//alert("Hashcode is " + userHashCode + ", task name is " + taskName + ", task hash code is " + taskHashCode);
		
		$.post("readSpecificTask.php",
				{taskNamePost: taskName },
				function(returnedData) {			
					
					var Jobj = JSON.parse(returnedData);
					
					var task;
					
					recursiveGetProp(Jobj,'taskConfig',function(obj){
						task = JSON.parse(obj);
					});	
					
					$("#taskName").val(task.taskName);
					$("#taskGeneralDescription").val(task.taskDescription);
					$("#startDate").val(task.startDate);
					$("#startHour").val(task.startHour);
					$("#startMinute").val(task.startMin);
					$("#endDate").val(task.endDate);
					$("#endHour").val(task.endHour);
					$("#endMinute").val(task.endMin);
					
					//Map display
					
					var AreaOfInterest_Mercator_List = task.AreaList_Mercator;
					console.log("List of shapes has length " + AreaOfInterest_Mercator_List.length);
					
					var shapeArray = [];
					for (var i=0;i < AreaOfInterest_Mercator_List.length;i++)
					{
						shapeArray.push(JSON.parse(AreaOfInterest_Mercator_List[i]));
					}
					
					
					var map, tb;
					
					
					var graphic;
					
						

					require([
					  "esri/map", "esri/toolbars/draw", "esri/symbols/SimpleFillSymbol", "esri/geometry/Point",
					  "esri/symbols/SimpleMarkerSymbol", "esri/symbols/SimpleLineSymbol",
					  "esri/symbols/PictureFillSymbol", "esri/symbols/CartographicLineSymbol", 
					  "esri/graphic", "esri/geometry/webMercatorUtils",
					  "esri/Color", "dojo/dom", "dojo/on", "dojo/domReady!", "esri/dijit/Search"
					], function(
					  Map, Draw,SimpleFillSymbol, Point,
					  SimpleMarkerSymbol, SimpleLineSymbol,
					  PictureFillSymbol, CartographicLineSymbol, 
					  Graphic, webMercatorUtils,
					  Color, dom, on, Search
					) {
					  map = new Map("mapDiv", {
						basemap: "streets",
						center: [11.589322, 50.928229],
						zoom: 13
					  });
					  map.on("load", initToolbar);		  
					  

					  // markerSymbol is used for point and multipoint, see http://raphaeljs.com/icons/#talkq for more examples
					  var markerSymbol = new SimpleMarkerSymbol();
					  markerSymbol.setPath("M16,4.938c-7.732,0-14,4.701-14,10.5c0,1.981,0.741,3.833,2.016,5.414L2,25.272l5.613-1.44c2.339,1.316,5.237,2.106,8.387,2.106c7.732,0,14-4.701,14-10.5S23.732,4.938,16,4.938zM16.868,21.375h-1.969v-1.889h1.969V21.375zM16.772,18.094h-1.777l-0.176-8.083h2.113L16.772,18.094z");
					  markerSymbol.setColor(new Color("#00FFFF"));

					  // lineSymbol used for freehand polyline, polyline and line. 
					  var lineSymbol = new CartographicLineSymbol(
						CartographicLineSymbol.STYLE_SOLID,
						new Color([255,0,0]), 10, 
						CartographicLineSymbol.CAP_ROUND,
						CartographicLineSymbol.JOIN_MITER, 5
					  );

					  // fill symbol used for extent, polygon and freehand polygon, use a picture fill symbol
					  // the images folder contains additional fill images, other options: sand.png, swamp.png or stiple.png
					  var fillSymbol = new SimpleFillSymbol();

					  function initToolbar() {
					  
						tb = new Draw(map);	
						tb.on("draw-end", addGraphic);
						tb.on("draw-end", customInitialize(shapeArray));				

						// event delegation so a click handler is not
						// needed for each individual button
						
						initFunc(map);
					  }
					  
					  function initFunc(map) {
							if( navigator.geolocation ) {
								navigator.geolocation.getCurrentPosition(zoomToLocation, locationError);
								//watchId = navigator.geolocation.watchPosition(showLocation, locationError);
							} else {
								alert("Browser doesn't support Geolocation. Visit http://caniuse.com to see browser support for the Geolocation API.");
							}
						}
					
					function locationError(error) {

							//error occurred so stop watchPosition
							if( navigator.geolocation ) {
								navigator.geolocation.clearWatch(watchId);
							}
							switch (error.code) {
								case error.PERMISSION_DENIED:
									alert("Location not provided");
									break;

								case error.POSITION_UNAVAILABLE:
									alert("Current location not available");
									break;

								case error.TIMEOUT:
									alert("Timeout");
									break;

								default:
									alert("unknown error");
									break;
							}
						}
						
					function zoomToLocation(location) {
							console.log("Zoom");
							var pt = new Point(location.coords.longitude, location.coords.latitude);
							map.centerAndZoom(pt, 13);
						}
						
						function customInitialize(arrayinput)
						  {
							  for (var i =0;i<arrayinput.length;i++)
								  {
									var newGraphic = new Graphic(arrayinput[i]);
									map.graphics.add(newGraphic);
								  }
						  }

					  function addGraphic(evt) {
						//deactivate the toolbar and clear existing graphics 
						tb.deactivate(); 
						map.enableMapNavigation();

						// figure out which symbol to use
						var symbol;
						if ( evt.geometry.type === "point" || evt.geometry.type === "multipoint") {
						  symbol = markerSymbol;
						} else if ( evt.geometry.type === "line" || evt.geometry.type === "polyline") {
						  symbol = lineSymbol;
						}
						else {
						  symbol = fillSymbol;
						}
						
						
						var newGraphic = new Graphic(evt.geometry, symbol);
						map.graphics.add(newGraphic);
						
						
					  }
					});
					
					
					//Map display End
					
					if ((userHashCode+taskHashCode)%3 == 0)  // Open bid
					{
						$('#openBid').toggle();
						
						$("#saveBid_Open").click(function(){
						
							var OpenFirst_price = $("#bidPrice_Open").val();
						
							//alert(email + " " + $("#bidPrice_Open").val() + " " + taskName);							
						
							$.post("PostBidPrice.php",
								{ user: 		email, 
								  bidPrice:		$("#bidPrice_Open").val(),
								  type:			'OpenFirst',
								  taskNamePost: taskName },
								function(data) {
								
									var sealedBidPriceArray = [];
									var openFirstBidPriceArray = [];
									
									var allBidPrice = [];
							
									//alert('Bid inserted ' + data);																		
									$('#otherBidInfo').toggle();							
									$('#toBeHidden').hide("slow");									
									$('#currentPrice').val(OpenFirst_price);
									
									var resultJob1,resultJob2;
									
									var job1 = $.post("get_BidPrice_By_Type.php",
										{ 
										  bidType:			'Closed',
										  taskNamePost: taskName },
										function(data) {
										
											var Jobj = JSON.parse(data);
										
											recursiveGetProp(Jobj,'bidPrice',function(obj){
												allBidPrice.push(parseFloat(obj));
											});

											//console.log("All sealed-bid price " + sealedBidPriceArray);											
									});
									
									var job2 = $.post("get_BidPrice_By_Type.php",
										{ 
										  bidType:			'OpenFirst',
										  taskNamePost: taskName },
										function(data) {
										
											var Jobj = JSON.parse(data);
										
											recursiveGetProp(Jobj,'bidPrice',function(obj){
												allBidPrice.push(parseFloat(obj));
											});

											//console.log("All open first-bid price " + openFirstBidPriceArray);											
									});
									
									$.when(job1,job2).done( function()
									{
																			
										
										allBidPrice.sort(sortNumber);
										console.log("All sorted bid price are " + allBidPrice + " and length is " + allBidPrice.length);
										
										if (allBidPrice.length > 0)
										{
											$('#minPrice').val(allBidPrice[0]);
											$('#firstQuartile').val(allBidPrice[Math.round(allBidPrice.length/4)]);
											console.log('First quartile index is ' + allBidPrice.length/4)
											$('#medianPrice').val(allBidPrice[Math.round(allBidPrice.length/2)]);
										}
										else
										{
											$('#minPrice').val(0);
											$('#firstQuartile').val(0);
											$('#medianPrice').val(0);
										}									
										
									});
									
									
							});						
						});
						
						$("#saveBid_Final").click(function(){		
							
						
							$.post("PostBidPrice.php",
								{ user: 		email, 
								  bidPrice:		$("#newPrice").val(),
								  type:			'Open_Final',
								  taskNamePost: taskName },
								function(data) {
							
									commonTask();
							});						
						});
					}
					else if ((userHashCode+taskHashCode)%3 == 1)  // Closed bid or sealed bid
					{
						$('#closedBid').toggle();
						
						$("#saveBid_Closed").click(function(){
						
							//alert(email + " " + $("#bidPrice_Closed").val() + " " + taskName);							
						
							$.post("PostBidPrice.php",
								{ user: 		email, 
								  bidPrice:		$("#bidPrice_Closed").val(),
								  type:			'Closed',
								  taskNamePost: taskName },
								function(data) {
							
									//alert('Bid inserted ' + data);									
									
									if ( !completedTaskArray.includes(taskName) )
									{
										completedTaskArray.push(taskName);										
									}
									
									sessionStorage.completedTask = JSON.stringify(completedTaskArray);									
									window.location.href = "listTask.html";									
							});						
						});
					}
					else   // Guided bid
					{
						$('#guidedBid').toggle();
						$('#expectedPrice').val(task.taskPrice);
						
						$("#saveBid_Guided").click(function(){
						
							//alert(email + " " + $("#bidPrice_Guided").val() + " " + taskName);							
						
							$.post("PostBidPrice.php",
								{ user: 		email, 
								  bidPrice:		$("#bidPrice_Guided").val(),
								  type:			'Guided',
								  taskNamePost: taskName },
								function(data) {
							
									//alert('Bid inserted ' + data);	
									if ( !completedTaskArray.includes(taskName) )
									{
										completedTaskArray.push(taskName);										
									}
									
									sessionStorage.completedTask = JSON.stringify(completedTaskArray);
									window.location.href = "listTask.html";									
							});							
						});
					}
			});
		
		function hashFnv32a(str, asString, seed) {
			/*jshint bitwise:false */
			var i, l,
				hval = (seed === undefined) ? 0x811c9dc5 : seed;

			for (i = 0, l = str.length; i < l; i++) {
				hval ^= str.charCodeAt(i);
				hval += (hval << 1) + (hval << 4) + (hval << 7) + (hval << 8) + (hval << 24);
			}
			if( asString ){
				// Convert to 8 digit hex string
				return ("0000000" + (hval >>> 0).toString(16)).substr(-8);
			}
			return hval >>> 0;
		}
		
		function recursiveGetProp(obj, lookup, callback) {
			for (property in obj) {
				if (property == lookup) {
					callback(obj[property]);
				} else if (obj[property] instanceof Object) {
					recursiveGetProp(obj[property], lookup, callback);
				}
			}
		}
		
		function sortNumber(a, b) {
		  return a - b;
		}
		
		function commonTask()
		{
			if ( !completedTaskArray.includes(taskName) )
				{
					completedTaskArray.push(taskName);										
				}
									
				sessionStorage.completedTask = JSON.stringify(completedTaskArray);
				window.location.href = "listTask.html";		
		}
	
	
			
				
	
				
		
	});
	</script>
	


</head>

<body class="calcite">

<div id="left" class=" col-lg-5" > 
Please read the descripton of the task 
<br><br>
<table style="width:80%">	  
		  
		  <tr>   
		    <th>Name of task</th>
		    <th> <input type="text"   disabled     class = "form-control" name="demail" id="taskName"> </th>
		  </tr>
		  
		  <tr>
		    <th>General description of task</th>
		    <th> <textarea type="text" disabled id="taskGeneralDescription"  class="form-control"style="width:70%;" rows="5" cols="60"></textarea> </th>
		  </tr>
		  
		  <tr> 
				<th> Start date </th> 
				<th> <input type="text" disabled class = "form-control" id="startDate"> </th>  
		  </tr>
		  <tr> 
				<th> Start time </th> 
				<th> <input type="text" disabled id="startHour" size="1"> : <input type="text" disabled id="startMinute" size="1">  </th>  
		  </tr>
		  <tr> 
				<th> End date </th> 
				<th> <input type="text" disabled class = "form-control" id="endDate"> </th>  
		  </tr> 
		  <tr> 
				<th> End time  </th> 
				<th> <input type="text" disabled id="endHour" size="1"> : <input type="text" disabled  id="endMinute" size="1">  </th>  
		  </tr>
		  
		  <tr> 
				<th>  </th> 
				<th>  </th>  
		  </tr>
	</table>
	
	<br><br>

<div id="openBid" style="display:none">

	<div id="otherBidInfo" style="display:none">
	How other people are bidding for this particluar task:
	<br>
	<br>
	The minimum price: <input type="text" disabled   id="minPrice">
	<br>
	The first quartile: <input type="text" disabled   id="firstQuartile">
	<br>
	The median: <input type="text" disabled   id="medianPrice">
	<br>
	<br>
	As you are informed of the other bids,do you want to make some changes to your bid to increase the chance of winning?
	<br>
	Your current bid price: <input type="text" disabled   id="currentPrice">
	<br>
	Your new bid price: <input type="text"    id="newPrice">
	<br>
	<br>
	<button id="saveBid_Final"  class="btn btn-warning">Save the final price</button>
	</div>
	
	<br>
	<br>
	
	<div id="toBeHidden">
	Based on the parameters of this task, please give your bid price below:
	Your bid price: <input type="text" class = "form-control"  id="bidPrice_Open">
	<br>
	<br>
	<button id="saveBid_Open"  class="btn btn-warning">Save the bid price</button>
	</div>
</div>

<div id="closedBid" style="display:none">	
	Based on the parameters of this task, please give your bid price (sealed-bid)
	<br>
	<br>
	Your bid price: <input type="text" class = "form-control"  id="bidPrice_Closed">
	<br>
	<br>
	<button id="saveBid_Closed"  class="btn btn-primary">Save the bid price</button>
	
</div>

<div id="guidedBid" style="display:none">	

	The expected bid price is: <input type="text" disabled   id="expectedPrice">
	<br>
	By bidding less than this price, you have more chance to win
	
	<br><br>
	
	
	Based on the parameters of this task, please give your bid price below:
	Your bid price: <input type="text" class = "form-control"  id="bidPrice_Guided">
	<br>
	<br>
	<button id="saveBid_Guided"  class="btn btn-success">Save the bid price</button>
	
</div>
</div>

<div id="right" class="col-lg-7 ">

<p> The area of interest for this task </p> <br>

	

    <div id="mapDiv"></div>
	
	
</div>
	

</body>
</html>
